<a id="mypy-boto3-synthetics"></a>

# mypy-boto3-synthetics

[![PyPI - types-aiobotocore-synthetics](https://img.shields.io/pypi/v/types-aiobotocore-synthetics.svg?color=blue)](https://pypi.org/project/types-aiobotocore-synthetics)
[![PyPI - Python Version](https://img.shields.io/pypi/pyversions/types-aiobotocore-synthetics.svg?color=blue)](https://pypi.org/project/types-aiobotocore-synthetics)
[![Docs](https://img.shields.io/readthedocs/mypy-boto3-builder.svg?color=blue)](https://mypy-boto3-builder.readthedocs.io/)
[![PyPI - Downloads](https://img.shields.io/pypi/dm/types-aiobotocore-synthetics?color=blue)](https://pypistats.org/packages/types-aiobotocore-synthetics)

![boto3.typed](https://github.com/vemel/mypy_boto3_builder/raw/main/logo.png)

Type annotations for
[boto3.Synthetics 1.20.47](https://boto3.amazonaws.com/v1/documentation/api/latest/reference/services/synthetics.html#Synthetics)
service compatible with [VSCode](https://code.visualstudio.com/),
[PyCharm](https://www.jetbrains.com/pycharm/),
[Emacs](https://www.gnu.org/software/emacs/),
[Sublime Text](https://www.sublimetext.com/),
[mypy](https://github.com/python/mypy),
[pyright](https://github.com/microsoft/pyright) and other tools.

Generated by
[mypy-boto3-builder 6.4.2](https://github.com/vemel/mypy_boto3_builder).

More information can be found on
[boto3-stubs](https://pypi.org/project/boto3-stubs/) page and in
[types-aiobotocore-synthetics docs](https://vemel.github.io/types_aiobotocore_docs/types_aiobotocore_synthetics/)

See how it helps to find and fix potential bugs:

![boto3-stubs demo](https://github.com/vemel/mypy_boto3_builder/raw/main/demo.gif)

- [mypy-boto3-synthetics](#mypy-boto3-synthetics)
  - [How to install](#how-to-install)
    - [VSCode extension](#vscode-extension)
    - [From PyPI with pip](#from-pypi-with-pip)
  - [Usage](#usage)
    - [VSCode](#vscode)
    - [PyCharm](#pycharm)
    - [Other IDEs](#other-ides)
    - [mypy](#mypy)
    - [pyright](#pyright)
  - [Explicit type annotations](#explicit-type-annotations)
    - [Client annotations](#client-annotations)
    - [Literals](#literals)
    - [Typed dictionaries](#typed-dictionaries)
  - [Versioning](#versioning)
  - [Documentation](#documentation)
  - [Support and contributing](#support-and-contributing)

<a id="how-to-install"></a>

## How to install

<a id="vscode-extension"></a>

### VSCode extension

Add
[AWS Boto3](https://marketplace.visualstudio.com/items?itemName=Boto3typed.boto3-ide)
extension to your VSCode and run `AWS boto3: Quick Start` command.

Click `Modify` and select `boto3 common` and `Synthetics`.

<a id="from-pypi-with-pip"></a>

### From PyPI with pip

Install `types-aiobotocore` for `Synthetics` service.

```bash
python -m pip install types-aiobotocore[synthetics]
```

<a id="usage"></a>

## Usage

<a id="vscode"></a>

### VSCode

- Install
  [Python extension](https://marketplace.visualstudio.com/items?itemName=ms-python.python)
- Install
  [Pylance extension](https://marketplace.visualstudio.com/items?itemName=ms-python.vscode-pylance)
- Set `Pylance` as your Python Language Server
- Install `types-aiobotocore[synthetics]` in your environment:
  `python -m pip install 'types-aiobotocore[synthetics]'`

Both type checking and auto-complete should work for `Synthetics` service. No
explicit type annotations required, write your `boto3` code as usual.

<a id="pycharm"></a>

### PyCharm

- Install `types-aiobotocore[synthetics]` in your environment:
  `python -m pip install 'types-aiobotocore[synthetics]'`

Both type checking and auto-complete should work for `Synthetics` service. No
explicit type annotations required, write your `aiobotocore` code as usual.
Auto-complete can be slow on big projects or if you have a lot of installed
`types-aiobotocore` submodules.

<a id="other-ides"></a>

### Other IDEs

Not tested, but as long as your IDE supports `mypy` or `pyright`, everything
should work.

<a id="mypy"></a>

### mypy

- Install `mypy`: `python -m pip install mypy`
- Install `types-aiobotocore[synthetics]` in your environment:
  `python -m pip install 'types-aiobotocore[synthetics]'`
- Run `mypy` as usual

Type checking should work for `Synthetics` service. No explicit type
annotations required, write your `aiobotocore` code as usual.

<a id="pyright"></a>

### pyright

- Install `pyright`: `yarn global add pyright`
- Install `types-aiobotocore[synthetics]` in your environment:
  `python -m pip install 'types-aiobotocore[synthetics]'`
- Optionally, you can install `boto3-stubs` to `typings` folder.

Type checking should work for `Synthetics` service. No explicit type
annotations required, write your `aiobotocore` code as usual.

<a id="explicit-type-annotations"></a>

## Explicit type annotations

<a id="client-annotations"></a>

### Client annotations

`SyntheticsClient` provides annotations for
`session.create_client("synthetics")`.

```python
from aiobotocore.session import get_session

from types_aiobotocore_synthetics import SyntheticsClient

session = get_session()
with async session.create_client("synthetics") as client:
    client: SyntheticsClient
    # now client usage is checked by mypy and IDE should provide code auto-complete
```

<a id="literals"></a>

### Literals

`types_aiobotocore_synthetics.literals` module contains literals extracted from
shapes that can be used in user code for type checking.

```python
from types_aiobotocore_synthetics.literals import (
    CanaryRunStateReasonCodeType,
    CanaryRunStateType,
    CanaryStateReasonCodeType,
    CanaryStateType,
    EncryptionModeType,
    ServiceName,
)

def check_value(value: CanaryRunStateReasonCodeType) -> bool:
    ...
```

<a id="typed-dictionaries"></a>

### Typed dictionaries

`types_aiobotocore_synthetics.type_defs` module contains structures and shapes
assembled to typed dictionaries for additional type checking.

```python
from types_aiobotocore_synthetics.type_defs import (
    ArtifactConfigInputTypeDef,
    ArtifactConfigOutputTypeDef,
    BaseScreenshotTypeDef,
    CanaryCodeInputTypeDef,
    CanaryCodeOutputTypeDef,
    CanaryLastRunTypeDef,
    CanaryRunConfigInputTypeDef,
    CanaryRunConfigOutputTypeDef,
    CanaryRunStatusTypeDef,
    CanaryRunTimelineTypeDef,
    CanaryRunTypeDef,
    CanaryScheduleInputTypeDef,
    CanaryScheduleOutputTypeDef,
    CanaryStatusTypeDef,
    CanaryTimelineTypeDef,
    CanaryTypeDef,
    CreateCanaryRequestRequestTypeDef,
    CreateCanaryResponseTypeDef,
    DeleteCanaryRequestRequestTypeDef,
    DescribeCanariesLastRunRequestRequestTypeDef,
    DescribeCanariesLastRunResponseTypeDef,
    DescribeCanariesRequestRequestTypeDef,
    DescribeCanariesResponseTypeDef,
    DescribeRuntimeVersionsRequestRequestTypeDef,
    DescribeRuntimeVersionsResponseTypeDef,
    GetCanaryRequestRequestTypeDef,
    GetCanaryResponseTypeDef,
    GetCanaryRunsRequestRequestTypeDef,
    GetCanaryRunsResponseTypeDef,
    ListTagsForResourceRequestRequestTypeDef,
    ListTagsForResourceResponseTypeDef,
    ResponseMetadataTypeDef,
    RuntimeVersionTypeDef,
    S3EncryptionConfigTypeDef,
    StartCanaryRequestRequestTypeDef,
    StopCanaryRequestRequestTypeDef,
    TagResourceRequestRequestTypeDef,
    UntagResourceRequestRequestTypeDef,
    UpdateCanaryRequestRequestTypeDef,
    VisualReferenceInputTypeDef,
    VisualReferenceOutputTypeDef,
    VpcConfigInputTypeDef,
    VpcConfigOutputTypeDef,
)

def get_structure() -> ArtifactConfigInputTypeDef:
    return {
      ...
    }
```

<a id="versioning"></a>

## Versioning

`types-aiobotocore-synthetics` version is the same as related `boto3` version
and follows [PEP 440](https://www.python.org/dev/peps/pep-0440/) format.

<a id="documentation"></a>

## Documentation

All type annotations can be found in
[types-aiobotocore-synthetics docs](https://vemel.github.io/types_aiobotocore_docs/types_aiobotocore_synthetics/)

<a id="support-and-contributing"></a>

## Support and contributing

This package is auto-generated. Please reports any bugs or request new features
in [mypy-boto3-builder](https://github.com/vemel/mypy_boto3_builder/issues/)
repository.
